// TP3 

#include "stdlib.h"
#include "memory.h"
#include "stdio.h"

#include "stringtab.h"
#include "grapheurbain.h"


/******************************************/
/******************************************/
int main(int argc, char* argv[])
{
	unsigned short i;
	grapheurbain g = grapheurbainNouv();

	// on utilise la table pour associer un nom (chaine de car) a chaque identifiant
	StringTab rues = StringTabNouv();
	char *srue[] = { "Zellenberg","Chapelle","Altkirch","Haute","Ancienne ecole",
		"Saint Hippolyte","Ziegelfeld" };
	for (i = 0; i < 7; i++) StringTabAdd(rues, srue[i]);

	StringTab carf = StringTabNouv();
	char *scar[] = { "ZW222","ZW221","ZW231","ZW232","ZW233","ZW234",
		"ZW241","ZW251","ZW250","ZW211","ZW100" };
	for (i = 0; i < 11; i++) StringTabAdd(carf, scar[i]);
	printf("\nCrer et Tester le graphe urbain\n");

	// on cre les 11 carrefours precedents dans le graphe
	for (unsigned int i=1; i<=11; i++) addCarrefour(&g, i);
	// on cre les arcs (rues)
	addArcDoubleSens(g, StringTabRech(carf,"ZW222"), StringTabRech(carf, "ZW221"), StringTabRech(rues, "Ziegelfeld"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW221"), StringTabRech(carf, "ZW231"), StringTabRech(rues, "Ziegelfeld"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW241"), StringTabRech(carf, "ZW231"), StringTabRech(rues, "Ziegelfeld"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW250"), StringTabRech(carf, "ZW241"), StringTabRech(rues, "Ziegelfeld"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW250"), StringTabRech(carf, "ZW251"), StringTabRech(rues, "Zellenberg"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW234"), StringTabRech(carf, "ZW251"), StringTabRech(rues, "Altkirch"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW233"), StringTabRech(carf, "ZW234"), StringTabRech(rues, "Saint Hippolyte"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW232"), StringTabRech(carf, "ZW233"), StringTabRech(rues, "Saint Hippolyte"));
	addArcDoubleSens(g, StringTabRech(carf,"ZW231"), StringTabRech(carf, "ZW232"), StringTabRech(rues, "Saint Hippolyte"));
	addArcDoubleSens(g, StringTabRech(carf, "ZW100"), StringTabRech(carf, "ZW233"), StringTabRech(rues, "Haute"));
	addArc(g, StringTabRech(carf, "ZW231"), StringTabRech(carf, "ZW211"), StringTabRech(rues, "Ancienne ecole"));
	
	printf("Dans le graphe urbain:\n");
	char *str;

	printf("Le carrefour ZW233 est incident aux rues:\n");
	listeui crois = ruesDeCarrefour(g, StringTabRech(carf, "ZW233"));
	for (i = 0; i<longlui(crois); i++)
	{
		str = StringTabGetChaine(rues, kiemelui(crois, i));
		printf("%s\n", str);
	}
	destroylui(crois);

	printf("La rue Zellenberg croise:\n");
	crois = ruesCroisement(g, StringTabRech(rues,"Zellenberg"));
	for (i = 0; i<longlui(crois); i++)
	{
		str = StringTabGetChaine(rues, kiemelui(crois, i));
		printf("rue %s\n", str);
	}
	destroylui(crois);

	grapheurbainFree(g);

	StringTabFree(rues);
	StringTabFree(carf);

	return 0;
}
