
#include "stdlib.h"
#include "string.h"
#include "memory.h"
#include "stdio.h"

/******************************************/
/*
// stringtab.h 
Table de chaines de caracteres
*/

#define N_ELEM_INIT 100

typedef unsigned int Nat;
typedef char *String;

typedef struct s_couple { // adressage associatif
	String	chaine;
	Nat	ident;
} couple;

typedef struct s_stringtab {
	couple		*tab;
	Nat			n_elem;		// nombre de chaines
	Nat			max_elem;	// taille du tableau tab
	Nat			curr_id;	// pour gnrer les identifiants uniques
} *StringTab;


StringTab StringTabNouv();
void StringTabFree(StringTab t);
Nat StringTabCardinal(StringTab t);
Nat StringTabAdd(StringTab t, String str);
void StringTabSup(StringTab t, String str);

// recherche de lidentifiant d'une chaine (recherche squentielle)
Nat StringTabRech(StringTab t, String str);
// recuperation de la chaine a partir de lidentifiant (recherche dichotomique)
String StringTabGetChaine(StringTab t, Nat index);



