# Projet de Structures de Données et Algorithmie

Ce dépôt contient des travaux pratiques réalisés dans le cadre de l'UE de Structures de Données et Algorithmie. Les TP incluent des implémentations de divers algorithmes et structures de données, ainsi que la modélisation de relations entre entités pour un outil d'aide à l'enquête criminelle.

## Contenu du dépôt

- **Algorithmes de tri** : Implémentation de différents algorithmes de tri pour organiser des données.
- **Dictionnaires avec chaînes de caractères** : Gestion et manipulation de dictionnaires utilisant des chaînes de caractères pour stocker et récupérer des informations.
- **Implémentation de voies urbaines** : Modélisation et gestion de réseaux urbains pour représenter des routes et des intersections.

## TP Noté : Modélisation des Relations entre Entités

Dans le cadre d'un outil d'aide à l'enquête criminelle, nous avons modélisé des relations entre différentes **entités**. Les entités incluent des objets, des lieux et des individus, et chaque entité possède les caractéristiques suivantes :

- **Nom** : Chaîne de caractères, unique pour chaque entité.
- **Type** : Chaque entité peut être de l'un des quatre types suivants :
  - Personne
  - Objet
  - Adresse
  - Ville

Nous utilisons un nom NULL pour représenter une valeur manquante (notée par \( \Omega \)).

### Modèle Relationnel

L'ensemble des entités qui sont en relation forme un **graphe** :

- Chaque relation entre les entités est étiquetée.
- Il ne peut y avoir qu'une seule relation entre deux mêmes entités, garantissant ainsi que le graphe est simple.
- Le graphe est **non-orienté** et **valué**, ce qui signifie que les relations ont des poids associés.

### Illustration

![Figure 1 - Ensemble des relations](relation.png)
