/**
 * \file binary_sort.c
 * \brief Binary sort.
 * \date 2017
 * \author YOU
 * \copyright WTFPLv2
 */

/* Copyright © 2017 YOU <you@etu.unistra.fr>
 *
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar.
 *
 * See http://www.wtfpl.net/ or read below for more details.
 */
/* DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *  0. You just DO WHAT THE FUCK YOU WANT TO.
 */
#include "custom_sort.h"

#include <string.h>
#include "array.h"

////////////////////////////////////////////////////////////////////////////////
// Your implementation.
////////////////////////////////////////////////////////////////////////////////

int recherche(long int* const tab, int a, int b, int x)
{
	if (a >= b) return a;
	int m = (a + b) / 2;
	if (tab[m]<x) return recherche(tab, m + 1, b, x);
	else return recherche(tab, a, m, x);
}
void inserer(long int* const tab, int n, int pos, int x)
{
	int i;
	for (i = n; i>pos; i--) tab[i] = tab[i - 1];
	tab[pos] = x;
}

long int* custom_sort(size_t size, long int* const array)
{
  long int* const result = malloc(size * sizeof *result);
  size_t i;
  for (i = 0; i<size; i++)
  {
	  int pos = recherche(result, 0, i, array[i]);
	  inserer(result, i, pos, array[i]);
  } 
  free(array);
  return result;
}

////////////////////////////////////////////////////////////////////////////////
// Other required functions.
////////////////////////////////////////////////////////////////////////////////

const char* custom_sort_name(void)
{
  return "binary_sort()";
}
