/**
 * \file quick_sort.c
 * \brief Quick sort.
 * \date 2017
 * \author YOU
 * \copyright WTFPLv2
 */

/* Copyright © 2017 YOU <you@etu.unistra.fr>
 *
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar.
 *
 * See http://www.wtfpl.net/ or read below for more details.
 */
/* DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *  0. You just DO WHAT THE FUCK YOU WANT TO.
 */
#include "custom_sort.h"

#include "array.h"

////////////////////////////////////////////////////////////////////////////////
// Your implementation.
////////////////////////////////////////////////////////////////////////////////
void tri_rapide(long int* const t, int a, int b)
{
	if (a >= b) return;
	long int pivot = t[(a+b)>>1];
	int i = a, j = b;
	while (i<=j)
	{
		while (t[i] < pivot) i++;
		while (t[j] > pivot) j--;
		if (i<=j) { long int buf = t[i]; t[i] = t[j]; t[j] = buf; i++; j--; }
	}
	tri_rapide(t, a, j);
	tri_rapide(t, i, b);
}

long int* custom_sort(size_t size, long int* const array)
{
	tri_rapide(array, 0, size - 1);
  return array;
}

////////////////////////////////////////////////////////////////////////////////
// Other required functions.
////////////////////////////////////////////////////////////////////////////////

const char* custom_sort_name(void)
{
  return "quick_sort()";
}
