// TP3  

#include "stdlib.h"
#include "memory.h"
#include "stdio.h"

#include "listeui.h"

/******************************************/
/*
// grapheurbain.h
*/
typedef unsigned int Nat;
typedef int boolean;

typedef struct strarc { Nat icf, irue; struct strarc *suc; } Strarc, *ListeSom;
typedef struct { Nat icf; ListeSom lsucc, lpred; } Sommet;
typedef struct strsom { Sommet c; struct strsom *suiv; } Strsom, *grapheurbain;

// operations de creation et destruction
grapheurbain grapheurbainNouv();
void grapheurbainFree(grapheurbain g);

// operations usuelles sur les graphes
void addCarrefour(grapheurbain *g, Nat icar);
void supCarrefour(grapheurbain *g, Nat icar);
void addArc(grapheurbain g, Nat idcarfx, Nat idcarfy, Nat idrue);
void addArcDoubleSens(grapheurbain g, Nat idcarfx, Nat idcarfy, Nat idrue);
void supArc(grapheurbain g, Nat idcarfx, Nat idcarfy);
boolean existeArc(grapheurbain g, Nat idcarfx, Nat idcarfy);
boolean existeCarrefour(grapheurbain g, Nat icar);
Nat nArcs(grapheurbain g);
Nat nCarrefours(grapheurbain g);

// operations sur les listes de successeurs et predecesseurs
// les carrefours associes a une rue
listeui carrefoursDeRue(grapheurbain g, Nat irue);
// les rues incidentes en un carrefour
listeui ruesDeCarrefour(grapheurbain g, Nat icar);
// les rues croisant une autre rue
listeui ruesCroisement(grapheurbain g, Nat irue);

// operations internes sur les listes chainees constituant le graph
// recherche le maillon qui contient icar
grapheurbain _rechCarrefour(grapheurbain g, Nat icar);
// recherche le maillon de ListeSom qui contient icar
ListeSom _rechArc(ListeSom ls, Nat icar);
// recherche le maillon de ListeSom qui contient irue
ListeSom _rechArcVal(ListeSom ls, Nat irue);
// supprime le maillon de ListeSom qui contient icar
ListeSom _supArc(ListeSom ls, Nat icar);
// ajoute en tte un maillon  ListeSom qui contient icar, irue
ListeSom _adjArc(ListeSom ls, Nat icar, Nat irue);


